
import javax.microedition.lcdui.*;

/**
 *
 * @author Tvc97
 */
public class TextInput {

    String[][] c, h;
    StringBuffer sb;
    int fh, bind, cind, smc;
    Font f;
    String cur;
    int sw, sh, count;
    long last;
    boolean upper, showCaret, showMethod;
    mCanvas mc;
    

    public TextInput(mCanvas mc) {
        this.mc = mc;
        sw = mc.w;
        sh = mc.h;
        c = new String[][]{
            {" ", "0"},
            {".", ",", "?", "!", "'", "\"", "1", "-", "(", ")", "@", "/", ":", "_"},
            {"a", "ă", "â", "b", "c", "2"},
            {"d", "đ", "e", "ê", "f", "3"},
            {"g", "h", "i", "4"},
            {"j", "k", "l", "5"},
            {"m", "n", "o", "ô", "ơ", "6"},
            {"p", "q", "r", "s", "7"},
            {"t", "u", "ư", "v", "8"},
            {"w", "x", "y", "z", "9"},
            {"́", "̀", "̉", "̃", "̣"}};

        h = new String[][]{
            {" ", "0"},
            {".", ",", "?", "!", "'", "\"", "1", "-", "(", ")", "@", "/", ":", "_"},
            {"A", "Ă", "Â", "B", "C", "2"},
            {"D", "Đ", "E", "Ê", "F", "3"},
            {"G", "H", "I", "4"},
            {"J", "K", "L", "5"},
            {"M", "N", "O", "Ô", "Ơ", "6"},
            {"P", "Q", "R", "S", "7"},
            {"T", "U", "Ư", "V", "8"},
            {"W", "X", "Y", "Z", "9"},
            {"́", "̀", "̉", "̃", "̣"}};

        sb = new StringBuffer();
        f = Font.getFont(0, 0, 8);
        fh = f.getHeight();

        last = now();

        bind = -1;
        cind = 0;

        upper = false;
        count = 0;
        smc = 0;
        showMethod = true;

    }

    public void draw(Graphics g, int x, int y, int w, int h) {
        g.setColor(0xaaaaaa);
        g.drawRoundRect(x, y, w, h, 4, 4);

        String str = sb.toString();
        if (cur != null) {
            str += cur;
        }
        if (showCaret || now() - last < 500 || f.stringWidth(str) > w) {
            str += "|";
        }

        g.setColor(0);
        if (f.stringWidth(str) > w) {
            if (cur != null) {
                g.setColor(0x47ce80);
                g.fillRect(sw - 4 - f.stringWidth(cur + "|"), y + 2, f.stringWidth(cur) + 2, fh + 1);
            }
            g.setClip(x + 2, y + 2, w, h);
            g.setColor(0);
            g.drawString(str, sw - 4 - f.stringWidth(str), y + 2, Graphics.TOP | Graphics.LEFT);
        } else {
            if (cur != null) {
                g.setColor(0x47ce80);
                g.fillRect(x + f.stringWidth(str) - f.stringWidth(cur + "|") + 1, y + 2, f.stringWidth(cur) + 2, fh + 1);
            }
            g.setClip(x + 2, y + 2, w, h);
            g.setColor(0);
            g.drawString(str, x + 2, y + 2, Graphics.TOP | Graphics.LEFT);
        }
        if (showMethod) {
            g.setClip(0, 0, sw, fh * 3);
            g.setColor(0xffffff);
            int strw = f.stringWidth("ABC") + 8;
            g.fillRoundRect(sw - strw - 4, 4, strw, fh + 2, 4, 4);
            g.setColor(0);
            g.drawString(upper ? "ABC" : "abc", sw - strw / 2 - 4, 5, Graphics.TOP | Graphics.HCENTER);
            smc++;
            if (smc >= 20) {
                showMethod = false;
                smc = 0;
            }
        }
    }

    public void update() {
        if (now() - last > 500) {
            if (cur != null) {
                sb.append(cur);
                last = now();
                cur = null;
                bind = -1;
                cind = 0;
            } else {
                bind = -1;
                cind = 0;
            }
        }

    }

    public void animate() {
        count++;
        if (count % 10 == 0) {
            showCaret = !showCaret;
        }
    }

    long now() {
        return System.currentTimeMillis();
    }

    public void next() {
        if (cur != null) {
            sb.append(cur);
            cur = null;
            bind = -1;
            cind = 0;
            last = now();
        }
    }

    public void addNumber(String num) {
        int na = Integer.parseInt(num);
        delete();
        cur = null;
        sb.append(num);
        bind = -1;
        cind = 0;
        last = now();

    }

    public void delete() {
        if (cur != null) {
            cur = null;
            bind = -1;
            cind = 0;
        } else {
            if (sb.toString().length() > 0) {
                sb.deleteCharAt(sb.toString().length() - 1);
            }
        }
        showCaret = true;
        count = 0;
    }

    public String getText() {
        if (cur != null) {
            sb.append(cur);
            cur = null;
            bind = -1;
            cind = 0;
        }
        return sb.toString();
    }

    public void deleteAll() {
        cur = null;
        bind = -1;
        cind = 0;
        if (sb.toString().length() > 0) {
            sb.delete(0, sb.toString().length());
        }
    }

    public void key(int k) {
        if (now() - last < 500) {
            if (bind != -1) {
                if (k == bind) {
                    cind++;
                    cind %= c[bind].length;
                    cur = upper ? h[bind][cind] : c[bind][cind];
                    last = now();
                } else {
                    if (cur != null) {
                        sb.append(cur);
                    }
                    bind = k;
                    cind = 0;
                    cur = upper ? h[bind][cind] : c[bind][cind];
                    last = now();
                }
            } else {
                bind = k;
                cind = 0;
                cur = upper ? h[bind][cind] : c[bind][cind];
                last = now();
            }
        } else {
            update();
            bind = k;
            cind = 0;
            cur = upper ? h[bind][cind] : c[bind][cind];
            last = now();
        }
    }
}
